//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "TCommThread.h"
#include "mainUnit.h"
#include "common.h"
#include "usb.h"

#pragma package(smart_init)

char read_buffer[200];

//zmienne importowane z common.cpp
extern struct usb_dev_handle *usb_handle;
extern int EP_OUT;      //endpoint USB
extern int EP_IN;
extern int transfer_type;          //bulk or interrupt ( 1 or 2 value )              

//---------------------------------------------------------------------------

__fastcall TCommThread::TCommThread(bool CreateSuspended)
        : TThread(CreateSuspended)
{
}

void __fastcall TCommThread::Add_received(void)
{
	char buf[4096];
    //ShowMessage("Add_received");
	switch(mainForm->settings.bRecvMode)
    {
    	case 0:
			mainForm->RichEdit1->Text = mainForm->RichEdit1->Text + read_buffer;
        	break;
        default:
            for(int i=0; i<ret; i++)
            {
   	        	sprintf(&buf[i*5], " 0x%02X", (unsigned char)read_buffer[i]);
            }
            mainForm->RichEdit1->Text = mainForm->RichEdit1->Text + (AnsiString)buf;
        	break;
    }
}


//---------------------------------------------------------------------------
void __fastcall TCommThread::Execute()
{
  FreeOnTerminate = true;   //automatic destroy on termination
  while(!Terminated)
  {
  if(usb_handle!=NULL) //port otwarty
    {
    if(transfer_type == 1)
        ret = usb_bulk_read( usb_handle, EP_IN, read_buffer, 128, 100 );
    else
        ret = usb_interrupt_read( usb_handle, EP_IN, read_buffer, 128, 100 );
    if(ret>0)
        {
        read_buffer[ret] = NULL;
        Synchronize(Add_received);
        }
    }//end if(hComm!=INVALID_HANDLE_VALUE)
  }//end while(1)
}
//---------------------------------------------------------------------------
